Index: trunk/sources/HeuristicLab.Permutation/3.3/AbsolutePositionTopologicalCrossover.cs
===================================================================
--- trunk/sources/HeuristicLab.Permutation/3.3/AbsolutePositionTopologicalCrossover.cs	(revision 2852)
+++ trunk/sources/HeuristicLab.Permutation/3.3/AbsolutePositionTopologicalCrossover.cs	(revision 2854)
@@ -1,5 +1,5 @@
 #region License Information
 /* HeuristicLab
- * Copyright (C) 2002-2008 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) 2002-2010 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.
@@ -25,4 +25,5 @@
 using HeuristicLab.Core;
 using HeuristicLab.Data;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
 
 namespace HeuristicLab.Permutation {
@@ -32,13 +33,15 @@
   /// (minding already inserted values).
   /// </summary>
+  /// <remarks>It is implemented as described in Moraglio, A. and Poli, R. 2005. Topological crossover for the permutation representation. In Proceedings of the 2005 Workshops on Genetic and Evolutionary Computation.<br />
+  /// </remarks>
   /// <example>First take the value at position 0 from parent1 then take the value at position 0
   /// from parent2 if it has not already been inserted, afterwards take the value at position 1 from
   /// parent1 if it has not already been inserted, then from parent2 and so on.</example>
-  public class AbsolutePositionTopologicalCrossover : PermutationCrossoverBase {
-    /// <inheritdoc select="summary"/>
-    public override string Description {
-      get { return @"TODO\r\nOperator description still missing ..."; }
-    }
-
+  [Item("AbsolutePositionTopologicalCrossover", @"An operator which performs a cross over permutation between two permutation arrays by taking the 
+entries with the same index (starting at position 0) from both parents 
+(minding already inserted values).")]
+  [EmptyStorableClass]
+  [Creatable("Test")]
+  public class AbsolutePositionTopologicalCrossover : PermutationCrossover {
     /// <summary>
     /// Performs a cross over permutation of <paramref name="parent1"/> and <paramref name="parent2"/>
@@ -48,9 +51,11 @@
     /// from parent2 if it has not already been inserted, afterwards take the value at position 1 from
     /// parent1 if it has not already been inserted, then from parent2 and so on.</example>
-    /// <param name="random">A random number generator.</param>
+    /// <exception cref="ArgumentException">Thrown when <paramref name="parent1"/> and <paramref name="parent2"/> are not of equal length.</exception>
+    /// <param name="random">The random number generator.</param>
     /// <param name="parent1">The parent scope 1 to cross over.</param>
     /// <param name="parent2">The parent scope 2 to cross over.</param>
     /// <returns>The created cross over permutation as int array.</returns>
-    public static int[] Apply(IRandom random, int[] parent1, int[] parent2) {
+    public static Permutation Apply(IRandom random, Permutation parent1, Permutation parent2) {
+      if (parent1.Length != parent2.Length) throw new ArgumentException("AbsolutePositionTopologicalCrossover: The parent permutations are of unequal length.");
       int length = parent1.Length;
       int[] result = new int[length];
@@ -71,5 +76,5 @@
         }
       }
-      return result;
+      return new Permutation(result);
     }
 
@@ -78,9 +83,8 @@
     /// </summary>
     /// <exception cref="InvalidOperationException">Thrown if there are not exactly two parents.</exception>
-    /// <param name="scope">The current scope.</param>
     /// <param name="random">A random number generator.</param>
     /// <param name="parents">An array containing the two permutations that should be crossed.</param>
     /// <returns>The newly created permutation, resulting from the crossover operation.</returns>
-    protected override int[] Cross(IScope scope, IRandom random, int[][] parents) {
+    protected override Permutation Cross(IRandom random, ItemArray<Permutation> parents) {
       if (parents.Length != 2) throw new InvalidOperationException("ERROR in AbsolutePositionTopologicalCrossover: The number of parents is not equal to 2");
       return Apply(random, parents[0], parents[1]);
Index: trunk/sources/HeuristicLab.Permutation/3.3/CosaCrossover.cs
===================================================================
--- trunk/sources/HeuristicLab.Permutation/3.3/CosaCrossover.cs	(revision 2852)
+++ trunk/sources/HeuristicLab.Permutation/3.3/CosaCrossover.cs	(revision 2854)
@@ -1,5 +1,5 @@
 #region License Information
 /* HeuristicLab
- * Copyright (C) 2002-2008 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) 2002-2010 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.
@@ -25,17 +25,16 @@
 using HeuristicLab.Core;
 using HeuristicLab.Data;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
 
 namespace HeuristicLab.Permutation {
   /// <summary>
-  /// Performs a cross over permutation between two permutation arrays by taking randomly chosen 
+  /// Performs a crossover operation between two permutation arrays by taking randomly chosen 
   /// reverse and forward intervals from the first permutation array inserting 
   /// it in the child on different positions depending on the second permutation array.
   /// </summary>
-  public class CosaCrossover : PermutationCrossoverBase {
-    /// <inheritdoc select="summary"/>
-    public override string Description {
-      get { return @"TODO\r\nOperator description still missing ..."; }
-    }
-
+  [Item("CosaCrossover", "An operator which performs a crossover operation between two permutation arrays by taking randomly chosen reverse and forward intervals from the first permutation array inserting it in the child on different positions depending on the second permutation array.")]
+  [EmptyStorableClass]
+  [Creatable("Test")]
+  public class CosaCrossover : PermutationCrossover {
     /// <summary>
     /// Performs a cross over permutation of <paramref name="parent1"/> and <paramref name="parent2"/>
@@ -44,9 +43,11 @@
     /// The remaining elements to be inserted are taken again from parent1 in the forward direction.
     /// </summary>
+    /// <exception cref="ArgumentException">Thrown when <paramref name="parent1"/> and <paramref name="parent2"/> are not of equal length.</exception>
     /// <param name="random">The random number generator.</param>
     /// <param name="parent1">The parent scope 1 to cross over.</param>
     /// <param name="parent2">The parent scope 2 to cross over.</param>
     /// <returns>The created cross over permutation as int array.</returns>
-    public static int[] Apply(IRandom random, int[] parent1, int[] parent2) {
+    public static Permutation Apply(IRandom random, Permutation parent1, Permutation parent2) {
+      if (parent1.Length != parent2.Length) throw new ArgumentException("CosaCrossover: The parent permutations are of unequal length.");
       int length = parent1.Length;
       int[] result = new int[length];
@@ -82,5 +83,5 @@
       }
       result[j] = parent1[crossPoint];  // last station: crosspoint
-      return result;
+      return new Permutation(result);
     }
 
@@ -89,9 +90,8 @@
     /// </summary>
     /// <exception cref="InvalidOperationException">Thrown if there are not exactly two parents.</exception>
-    /// <param name="scope">The current scope.</param>
     /// <param name="random">A random number generator.</param>
     /// <param name="parents">An array containing the two permutations that should be crossed.</param>
     /// <returns>The newly created permutation, resulting from the crossover operation.</returns>
-    protected override int[] Cross(IScope scope, IRandom random, int[][] parents) {
+    protected override Permutation Cross(IRandom random, ItemArray<Permutation> parents) {
       if (parents.Length != 2) throw new InvalidOperationException("ERROR in CosaCrossover: The number of parents is not equal to 2");
       return Apply(random, parents[0], parents[1]);
Index: trunk/sources/HeuristicLab.Permutation/3.3/CyclicCrossover.cs
===================================================================
--- trunk/sources/HeuristicLab.Permutation/3.3/CyclicCrossover.cs	(revision 2852)
+++ trunk/sources/HeuristicLab.Permutation/3.3/CyclicCrossover.cs	(revision 2854)
@@ -31,5 +31,5 @@
   /// The operator first determines all cycles in the permutation and then composes the offspring by alternating between the cycles of the two parents.
   /// </remarks>
-  [Item("CyclicCrossover", "An operator which performs the cyclic crossover on two permutations as described in Eiben, A.E. and Smith, J.E. 2003. Introduction to Evolutionary Computation. Natural Computing Series, Springer-Verlag Berlin Heidelberg.")]
+  [Item("CyclicCrossover", "An operator which performs the cyclic crossover on two permutations.")]
   [EmptyStorableClass]
   [Creatable("Test")]
@@ -47,4 +47,5 @@
     /// The stochasticity of this operator is rather low. There are only two possible outcomes for a given pair of parents.
     /// </remarks>
+    /// <exception cref="ArgumentException">Thrown if the two parents are not of equal length.</exception>
     /// <param name="random">The random number generator.</param>
     /// <param name="parent1">The parent scope 1 to cross over.</param>
@@ -77,10 +78,11 @@
           if (copyFromParent1) {
             result[j] = parent1[j]; // copy number at position j from parent1
+            indexCopied[j] = true;
             j = invParent2[result[j]]; // set position j to the position of the copied number in parent2
           } else {
             result[j] = parent2[j]; // copy number at position j from parent2
+            indexCopied[j] = true;
             j = invParent1[result[j]]; // set position j to the position of the copied number in parent1
           }
-          indexCopied[j] = true;
         } while (!indexCopied[j]);
         copyFromParent1 = !copyFromParent1;
@@ -96,5 +98,4 @@
     /// </summary>
     /// <exception cref="InvalidOperationException">Thrown if there are not exactly two parents.</exception>
-    /// <param name="scope">The current scope.</param>
     /// <param name="random">A random number generator.</param>
     /// <param name="parents">An array containing the two permutations that should be crossed.</param>
Index: trunk/sources/HeuristicLab.Permutation/3.3/EdgeRecombinationCrossover.cs
===================================================================
--- trunk/sources/HeuristicLab.Permutation/3.3/EdgeRecombinationCrossover.cs	(revision 2852)
+++ trunk/sources/HeuristicLab.Permutation/3.3/EdgeRecombinationCrossover.cs	(revision 2854)
@@ -1,5 +1,5 @@
 #region License Information
 /* HeuristicLab
- * Copyright (C) 2002-2008 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) 2002-2010 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.
@@ -25,4 +25,5 @@
 using HeuristicLab.Core;
 using HeuristicLab.Data;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
 
 namespace HeuristicLab.Permutation {
@@ -32,10 +33,11 @@
   /// number of neighbours, the next again a neighbour and so on.
   /// </summary>
-  public class EdgeRecombinationCrossover : PermutationCrossoverBase {
-    /// <inheritdoc select="summary"/>
-    public override string Description {
-      get { return @"TODO\r\nOperator description still missing ..."; }
-    }
-
+  ///   /// <remarks>It is implemented as described in Whitley et.al. 1991, The Traveling Salesman and Sequence Scheduling, in Davis, L. (Ed.), Handbook ov Genetic Algorithms, New York, pp. 350-372<br />
+  /// The operator first determines all cycles in the permutation and then composes the offspring by alternating between the cycles of the two parents.
+  /// </remarks>
+  [Item("EdgeRecombinationCrossover", "An operator which performs the edge recombination crossover on two permutations.")]
+  [EmptyStorableClass]
+  [Creatable("Test")]
+  public class EdgeRecombinationCrossover : PermutationCrossover {
     /// <summary>
     /// Performs a cross over permutation of <paramref name="parent1"/> and <paramref name="2"/>
@@ -44,4 +46,5 @@
     /// number of neighbours, the next again a neighbour and so on.
     /// </summary>
+    /// <exception cref="ArgumentException">Thrown when <paramref name="parent1"/> and <paramref name="parent2"/> are not of equal length.</exception>
     /// <exception cref="InvalidOperationException">Thrown when the permutation lacks a number.
     /// </exception>
@@ -50,5 +53,6 @@
     /// <param name="parent2">The parent scope 2 to cross over.</param>
     /// <returns>The created cross over permutation as int array.</returns>
-    public static int[] Apply(IRandom random, int[] parent1, int[] parent2) {
+    public static Permutation Apply(IRandom random, Permutation parent1, Permutation parent2) {
+      if (parent1.Length != parent2.Length) throw new ArgumentException("EdgeRecombinationCrossover: The parent permutations are of unequal length.");
       int length = parent1.Length;
       int[] result = new int[length];
@@ -135,5 +139,5 @@
         }
       }
-      return result;
+      return new Permutation(result);
     }
 
@@ -142,9 +146,8 @@
     /// </summary>
     /// <exception cref="InvalidOperationException">Thrown if there are not exactly two parents.</exception>
-    /// <param name="scope">The current scope.</param>
     /// <param name="random">A random number generator.</param>
     /// <param name="parents">An array containing the two permutations that should be crossed.</param>
     /// <returns>The newly created permutation, resulting from the crossover operation.</returns>
-    protected override int[] Cross(IScope scope, IRandom random, int[][] parents) {
+    protected override Permutation Cross(IRandom random, ItemArray<Permutation> parents) {
       if (parents.Length != 2) throw new InvalidOperationException("ERROR in EdgeRecombinationCrossover: The number of parents is not equal to 2");
       return Apply(random, parents[0], parents[1]);
Index: trunk/sources/HeuristicLab.Permutation/3.3/HeuristicLab.Permutation-3.3.csproj
===================================================================
--- trunk/sources/HeuristicLab.Permutation/3.3/HeuristicLab.Permutation-3.3.csproj	(revision 2852)
+++ trunk/sources/HeuristicLab.Permutation/3.3/HeuristicLab.Permutation-3.3.csproj	(revision 2854)
@@ -82,9 +82,14 @@
   <ItemGroup>
     <None Include="HeuristicLabPermutationPlugin.cs.frame" />
+    <Compile Include="AbsolutePositionTopologicalCrossover.cs" />
+    <Compile Include="CosaCrossover.cs" />
     <Compile Include="CyclicCrossover.cs" />
+    <Compile Include="EdgeRecombinationCrossover.cs" />
+    <Compile Include="InsertionManipulator.cs" />
     <Compile Include="InversionManipulator.cs">
       <SubType>Code</SubType>
     </Compile>
     <Compile Include="MaximalPreservativeCrossover.cs" />
+    <Compile Include="OrderBasedCrossover.cs" />
     <Compile Include="PartiallyMatchedCrossover.cs" />
     <Compile Include="PermutationManipulator.cs" />
@@ -93,6 +98,12 @@
     <Compile Include="PermutationCrossover.cs" />
     <Compile Include="Permutation.cs" />
+    <Compile Include="PositionBasedCrossover.cs" />
     <Compile Include="Properties\AssemblyInfo.cs" />
     <Compile Include="RandomPermutationCreator.cs" />
+    <Compile Include="ScrambleManipulator.cs" />
+    <Compile Include="Swap2Manipulator.cs" />
+    <Compile Include="Swap3Manipulator.cs" />
+    <Compile Include="TranslocationInversionManipulator.cs" />
+    <Compile Include="TranslocationManipulator.cs" />
   </ItemGroup>
   <ItemGroup>
Index: trunk/sources/HeuristicLab.Permutation/3.3/InsertionManipulator.cs
===================================================================
--- trunk/sources/HeuristicLab.Permutation/3.3/InsertionManipulator.cs	(revision 2852)
+++ trunk/sources/HeuristicLab.Permutation/3.3/InsertionManipulator.cs	(revision 2854)
@@ -1,5 +1,5 @@
 #region License Information
 /* HeuristicLab
- * Copyright (C) 2002-2008 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) 2002-2010 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.
@@ -24,15 +24,17 @@
 using System.Text;
 using HeuristicLab.Core;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
 
 namespace HeuristicLab.Permutation {
   /// <summary>
   /// Manipulates a permutation array by moving randomly one element to another position in the array.
-  /// </summary>
-  public class InsertionManipulator : PermutationManipulatorBase {
-    /// <inheritdoc select="summary"/>
-    public override string Description {
-      get { return @"TODO\r\nOperator description still missing ..."; }
-    }
-
+  /// </summary> 
+  /// <remarks>
+  /// It is implemented as described in Fogel, D.B. (1988). An Evolutionary Approach to the Traveling Salesman Problem, Biological Cybernetics, 60, pp. 139-144
+  /// </remarks>
+  [Item("InsertionManipulator", "An operator which moves randomly one element to another position in the permutation.")]
+  [EmptyStorableClass]
+  [Creatable("Test")]
+  public class InsertionManipulator : PermutationManipulator {
     /// <summary>
     /// Moves an randomly chosen element in the specified <paramref name="permutation"/> array 
@@ -40,31 +42,29 @@
     /// </summary>
     /// <param name="random">The random number generator.</param>
-    /// <param name="permutation">The array to manipulate.</param>
-    /// <returns>The new permuation array with the manipulated data.</returns>
-    public static int[] Apply(IRandom random, int[] permutation) {
-      int[] result = (int[])permutation.Clone();
+    /// <param name="permutation">The permutation to manipulate.</param>
+    public static void Apply(IRandom random, Permutation permutation) {
+      Permutation original = (Permutation)permutation.Clone();
       int cutIndex, insertIndex, number;
 
-      cutIndex = random.Next(permutation.Length);
-      insertIndex = random.Next(permutation.Length);
-      number = permutation[cutIndex];
+      cutIndex = random.Next(original.Length);
+      insertIndex = random.Next(original.Length);
+      number = original[cutIndex];
 
       int i = 0;  // index in new permutation
       int j = 0;  // index in old permutation
-      while (i < permutation.Length) {
+      while (i < original.Length) {
         if (j == cutIndex) {
           j++;
         }
         if (i == insertIndex) {
-          result[i] = number;
+          permutation[i] = number;
           i++;
         }
-        if ((i < permutation.Length) && (j < permutation.Length)) {
-          result[i] = permutation[j];
+        if ((i < original.Length) && (j < original.Length)) {
+          permutation[i] = original[j];
           i++;
           j++;
         }
       }
-      return result;
     }
 
@@ -74,10 +74,8 @@
     /// </summary>
     /// <remarks>Calls <see cref="Apply"/>.</remarks>
-    /// <param name="scope">The current scope.</param>
-    /// <param name="random">The random number generator.</param>
-    /// <param name="permutation">The array to manipulate.</param>
-    /// <returns>The new permuation array with the manipulated data.</returns>
-    protected override int[] Manipulate(IScope scope, IRandom random, int[] permutation) {
-      return Apply(random, permutation);
+    /// <param name="random">A random number generator.</param>
+    /// <param name="permutation">The permutation to manipulate.</param>
+    protected override void Manipulate(IRandom random, Permutation permutation) {
+      Apply(random, permutation);
     }
   }
Index: trunk/sources/HeuristicLab.Permutation/3.3/InversionManipulator.cs
===================================================================
--- trunk/sources/HeuristicLab.Permutation/3.3/InversionManipulator.cs	(revision 2852)
+++ trunk/sources/HeuristicLab.Permutation/3.3/InversionManipulator.cs	(revision 2854)
@@ -27,4 +27,7 @@
   /// An operator which inverts a randomly chosen part of a permutation.
   /// </summary>
+  /// <remarks>
+  /// It is implemented as described in Eiben, A.E. and Smith, J.E. 2003. Introduction to Evolutionary Computation. Natural Computing Series, Springer-Verlag Berlin Heidelberg.<br />
+  /// </remarks>
   [Item("InversionManipulator", "An operator which inverts a randomly chosen part of a permutation.")]
   [EmptyStorableClass]
@@ -36,5 +39,4 @@
     /// <param name="random">A random number generator.</param>
     /// <param name="permutation">The permutation to manipulate.</param>
-    /// <returns>The new manipulated permutation.</returns>
     public static void Apply(IRandom random, Permutation permutation) {
       int breakPoint1, breakPoint2;
@@ -58,5 +60,4 @@
     /// <param name="random">A random number generator.</param>
     /// <param name="permutation">The permutation to manipulate.</param>
-    /// <returns>The new manipulated permuation.</returns>
     protected override void Manipulate(IRandom random, Permutation permutation) {
       Apply(random, permutation);
Index: trunk/sources/HeuristicLab.Permutation/3.3/MaximalPreservativeCrossover.cs
===================================================================
--- trunk/sources/HeuristicLab.Permutation/3.3/MaximalPreservativeCrossover.cs	(revision 2852)
+++ trunk/sources/HeuristicLab.Permutation/3.3/MaximalPreservativeCrossover.cs	(revision 2854)
@@ -34,5 +34,5 @@
   /// If the length of the permutation is smaller than 15, the size of the segment is always equal to 3.
   /// </remarks>
-  [Item("MaximalPreservativeCrossover", "An operator which performs the maximal preservative crossover on two permutations as described in Mühlenbein, H. 1991. Evolution in time and space - the parallel genetic algorithm. FOUNDATIONS OF GENETIC ALGORITHMS, pp. 316-337. Morgan Kaufmann.")]
+  [Item("MaximalPreservativeCrossover", "An operator which performs the maximal preservative crossover on two permutations.")]
   [EmptyStorableClass]
   [Creatable("Test")]
@@ -131,5 +131,4 @@
     /// </summary>
     /// <exception cref="InvalidOperationException">Thrown if there are not exactly two permutations in <paramref name="parents"/>.</exception>
-    /// <param name="scope">The current scope.</param>
     /// <param name="random">A random number generator.</param>
     /// <param name="parents">An array containing the two permutations that should be crossed.</param>
Index: trunk/sources/HeuristicLab.Permutation/3.3/OrderBasedCrossover.cs
===================================================================
--- trunk/sources/HeuristicLab.Permutation/3.3/OrderBasedCrossover.cs	(revision 2852)
+++ trunk/sources/HeuristicLab.Permutation/3.3/OrderBasedCrossover.cs	(revision 2854)
@@ -1,5 +1,5 @@
 #region License Information
 /* HeuristicLab
- * Copyright (C) 2002-2008 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) 2002-2010 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.
@@ -25,4 +25,5 @@
 using HeuristicLab.Core;
 using HeuristicLab.Data;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
 
 namespace HeuristicLab.Permutation {
@@ -32,10 +33,12 @@
   /// the missing entries with the elements from the second permutation, also in the right order.
   /// </summary>
-  public class OrderBasedCrossover : PermutationCrossoverBase {
-    /// <inheritdoc select="summary"/>
-    public override string Description {
-      get { return @"TODO\r\nOperator description still missing ..."; }
-    }
-
+  /// <remarks>
+  /// Implemented as described in Syswerda, G. (1991). Schedule Optimization Using Genetic Algorithms,
+  /// in Davis, L. (Ed.) Handbook of Genetic Algorithms, Van Nostrand Reinhold, New York, pp 332-349.
+  /// </remarks>
+  [Item("OrderBasedCrossover", "An operator which performs an order based crossover of two permutations.")]
+  [EmptyStorableClass]
+  [Creatable("Test")]
+  public class OrderBasedCrossover : PermutationCrossover {
     /// <summary>
     /// Performs a cross over permutation of <paramref name="parent1"/> and <paramref name="parent2"/> by
@@ -43,9 +46,11 @@
     /// other; the missing ones are picked in the correct order from the second permutation.
     /// </summary>
-    /// <param name="random">The random number generator.</param>
-    /// <param name="parent1">The parent scope 1 to cross over.</param>
-    /// <param name="parent2">The parent scope 2 to cross over.</param>
-    /// <returns>The created cross over permutation as int array.</returns>
-    public static int[] Apply(IRandom random, int[] parent1, int[] parent2) {
+    /// <exception cref="ArgumentException">Thrown when <paramref name="parent1"/> and <paramref name="parent2"/> are not of equal length.</exception>
+    /// <param name="random">A random number generator.</param>
+    /// <param name="parent1">The first parent permutation to cross.</param>
+    /// <param name="parent2">The second parent permutation to cross.</param>
+    /// <returns>The new permutation resulting from the crossover.</returns>
+    public static Permutation Apply(IRandom random, Permutation parent1, Permutation parent2) {
+      if (parent1.Length != parent2.Length) throw new ArgumentException("OrderBasedCrossover: The parent permutations are of unequal length.");
       int length = parent1.Length;
       int[] result = new int[length];
@@ -88,5 +93,5 @@
         }
       }
-      return result;
+      return new Permutation(result);
     }
 
@@ -95,10 +100,9 @@
     /// </summary>
     /// <exception cref="InvalidOperationException">Thrown if there are not exactly two parents.</exception>
-    /// <param name="scope">The current scope.</param>
     /// <param name="random">A random number generator.</param>
     /// <param name="parents">An array containing the two permutations that should be crossed.</param>
-    /// <returns>The newly created permutation, resulting from the crossover operation.</returns>
-    protected override int[] Cross(IScope scope, IRandom random, int[][] parents) {
-      if (parents.Length != 2) throw new InvalidOperationException("ERROR in OrderBasedCrossover: The number of parents is not equal to 2");
+    /// <returns>The new permutation resulting from the crossover.</returns>
+    protected override Permutation Cross(IRandom random, ItemArray<Permutation> parents) {
+      if (parents.Length != 2) throw new InvalidOperationException("OrderCrossover: Number of parents is not equal to 2.");
       return Apply(random, parents[0], parents[1]);
     }
Index: trunk/sources/HeuristicLab.Permutation/3.3/OrderCrossover.cs
===================================================================
--- trunk/sources/HeuristicLab.Permutation/3.3/OrderCrossover.cs	(revision 2852)
+++ trunk/sources/HeuristicLab.Permutation/3.3/OrderCrossover.cs	(revision 2854)
@@ -34,5 +34,5 @@
   /// in the order they occur.
   /// </remarks>
-  [Item("OrderCrossover", "An operator which performs an order crossover of two permutations as described in Eiben, A.E. and Smith, J.E. 2003. Introduction to Evolutionary Computation. Natural Computing Series, Springer-Verlag Berlin Heidelberg.")]
+  [Item("OrderCrossover", "An operator which performs an order crossover of two permutations.")]
   [EmptyStorableClass]
   [Creatable("Test")]
Index: trunk/sources/HeuristicLab.Permutation/3.3/PartiallyMatchedCrossover.cs
===================================================================
--- trunk/sources/HeuristicLab.Permutation/3.3/PartiallyMatchedCrossover.cs	(revision 2852)
+++ trunk/sources/HeuristicLab.Permutation/3.3/PartiallyMatchedCrossover.cs	(revision 2854)
@@ -33,5 +33,5 @@
   /// as the original source of the operator.
   /// </remarks>
-  [Item("PartiallyMatchedCrossover", "An operator which performs the partially matched crossover on two permutations as described in Fogel, D.B. 1988. An Evolutionary Approach to the Traveling Salesman Problem. Biological Cybernetics, 60, pp. 139-144, Springer-Verlag.")]
+  [Item("PartiallyMatchedCrossover", "An operator which performs the partially matched crossover on two permutations.")]
   [EmptyStorableClass]
   [Creatable("Test")]
@@ -92,5 +92,4 @@
     /// </summary>
     /// <exception cref="InvalidOperationException">Thrown if there are not exactly two permutations in <paramref name="parents"/>.</exception>
-    /// <param name="scope">The current scope.</param>
     /// <param name="random">A random number generator.</param>
     /// <param name="parents">An array containing the two permutations that should be crossed.</param>
